/*-

PBX-MX_Hal_COM

CopyRight PROBOTIX

*/
#define   XSTEP    2
#define   XDIR      3
#define   Y1STEP    4
#define   Y1DIR      5
#define   Y2STEP    6
#define   Y2DIR      7
#define   ZSTEP      8
#define   ZDIR         9
#define   ASTEP      10
#define   ADIR        11
#define   SPDL         12
#define   LED          13 
#define   COOL        A0
#define   XLIMIT       A1
#define   Y1LIMIT     A2
#define   Y2LIMIT     A3
#define   ZLIMIT       A4
#define   ESTOP       A5
#define   SPDLI      A6
#define   COOLI     A7

#define DELAY1 100
#define DELAY2  500

void setup() {
  Serial.begin(9600);
  pinMode(XSTEP, INPUT);
  pinMode(XDIR, INPUT);
  pinMode(Y1STEP, INPUT);
  pinMode(Y1DIR, INPUT);
  pinMode(Y2STEP, INPUT);
  pinMode(Y2DIR, INPUT);
  pinMode(ZSTEP, INPUT);
  pinMode(ZDIR, INPUT);
  pinMode(ASTEP, INPUT);
  pinMode(ADIR, INPUT);
  pinMode(SPDL, OUTPUT);
  pinMode(LED, OUTPUT);
  pinMode(COOL, OUTPUT);
  pinMode(XLIMIT, INPUT);
  pinMode(Y1LIMIT, INPUT);
  pinMode(Y2LIMIT, INPUT);
  pinMode(ZLIMIT, INPUT);
  pinMode(SPDLI, INPUT);
  pinMode(COOLI, INPUT);
  pinMode(ESTOP, INPUT);
}

uint8_t firstbyte=0;
int blinkState = 0; //0-start, 1-first blink, 2-second blink
int ledState = LOW;
unsigned long previousTime = 0;

void loop(){
  while(Serial.available()) {
        uint8_t byte = Serial.read();
        if((firstbyte == 0x8A) && (byte == 0x8A)) {
            // got a packet
            flashLED();
            if(analogRead(SPDLI) > 500)
              digitalWrite(SPDL, HIGH);
            else
              digitalWrite(SPDL, LOW);
            if(analogRead(COOLI) > 500)
              digitalWrite(COOL, HIGH);
            else
              digitalWrite(COOL, LOW);
        }
        else{
          digitalWrite(LED, LOW);
          digitalWrite(SPDL, LOW);
          digitalWrite(COOL, LOW);
        }
        
        firstbyte = byte;
    }
}


void flashLED(){
  unsigned long currentTime = millis();
  if(blinkState == 0 && ((currentTime - previousTime) >= DELAY2)){
    digitalWrite(LED, HIGH);
    previousTime = currentTime;
    blinkState = 1;
    ledState = HIGH;
  }
  else if(blinkState == 1 && ((currentTime - previousTime) >= DELAY1)){
    if(ledState == HIGH){
      digitalWrite(LED, LOW);
      previousTime = currentTime;
      ledState = LOW;
    }
    else{
      digitalWrite(LED, HIGH);
      previousTime = currentTime;
      ledState = HIGH;
      blinkState = 2;
    }
  }
  else if(blinkState == 2 && ((currentTime - previousTime) >= DELAY1)){
    digitalWrite(LED, LOW);
    previousTime = currentTime;
    blinkState = 0;
    ledState = LOW;
  }
}

